-------------------------------------------------------------------------------
-- Mob Framework Mod by Sapier
--
-- You may copy, use, modify or do nearly anything except removing this
-- copyright notice.
-- And of course you are NOT allow to pretend you have written it.
--
--! @file init.lua
--! @brief animalmaterials
--! @copyright Sapier
--! @author Sapier
--! @date 2013-01-27
--
-- Contact sapier a t gmx net
-------------------------------------------------------------------------------
local S
if (minetest.get_modpath("intllib")) then
  dofile(minetest.get_modpath("intllib").."/intllib.lua")
  S = intllib.Getter(minetest.get_current_modname())
else
  S = function ( s ) return s end
end

animalmaterialsdata = {}

minetest.register_tool("animalmaterials:sword_demondeath", {
	description = S("Sword (Demondeath)"),
	inventory_image = "default_tool_steelsword.png",
	tool_capabilities = {
		full_punch_interval = 0.50,
		max_drop_level=1,
		groupcaps={
			fleshy={times={[1]=2.00, [2]=0.80, [3]=0.40}, uses=10, maxlevel=1},
			snappy={times={[2]=0.70, [3]=0.30}, uses=40, maxlevel=1},
			choppy={times={[3]=0.70}, uses=40, maxlevel=0},
			demon={times={[1]=5, [2]=3, [3]=1}, uses=30, maxlevel=3},
		},
		damage_groups = {fleshy=2,demon=10},
	}
	})

minetest.register_tool("animalmaterials:scissors", {
	description = S("Scissors"),
	inventory_image = "animalmaterials_scissors.png",
	tool_capabilities = {
		max_drop_level=0,
		groupcaps={
			wool={uses=40,maxlevel=1}
		}
	},
})

minetest.register_craftitem("animalmaterials:lasso", {
	description = S("Lasso"),
	image = "animalmaterials_lasso.png",
	stack_max=10,
})

minetest.register_craftitem("animalmaterials:net", {
	description = S("Net"),
	image = "animalmaterials_net.png",
	stack_max=10,
})

minetest.register_craftitem("animalmaterials:saddle", {
	description = S("Saddle"),
	image = "animalmaterials_saddle.png",
	stack_max=1
})

minetest.register_craftitem("animalmaterials:contract", {
	description = S("Contract"),
	image = "animalmaterials_contract.png",
	stack_max=10,
})

minetest.register_craftitem("animalmaterials:meat_pork", {
	description = S("Pork (raw)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },
	stack_max=25
})

minetest.register_craftitem("animalmaterials:meat_beef", {
	description = S("Beef (raw)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },
	stack_max=25
})

minetest.register_craftitem("animalmaterials:meat_chicken", {
	description = S("Chicken (raw)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },
	stack_max=25
})

minetest.register_craftitem("animalmaterials:meat_lamb", {
	description = S("Lamb (raw)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },
	stack_max=25
})
minetest.register_craftitem("animalmaterials:meat_venison", {
	description = S("Venison (raw)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },
	stack_max=25
})
minetest.register_craftitem("animalmaterials:meat_undead", {
	description = S("Meat (not quite dead)"),
	image = "animalmaterials_meat_undead_raw.png",
	on_use = minetest.item_eat(-2),
	groups = { meat=1, eatable=1 },
	stack_max=5
})
minetest.register_craftitem("animalmaterials:meat_toxic", {
	description = S("Toxic Meat"),
	image = "animalmaterials_meat_toxic_raw.png",
	on_use = minetest.item_eat(-5),
	groups = { meat=1, eatable=1 },
	stack_max=5
})
minetest.register_craftitem("animalmaterials:meat_ostrich", {
	description = S("Ostrich Meat"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(3),
	groups = { meat=1, eatable=1 },
	stack_max=5
})

minetest.register_craftitem("animalmaterials:fish_bluewhite", {
	description = S("Fish (bluewhite)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },

})

minetest.register_craftitem("animalmaterials:fish_clownfish", {
	description = S("Fish (clownfish)"),
	image = "animalmaterials_meat_raw.png",
	on_use = minetest.item_eat(1),
	groups = { meat=1, eatable=1 },
})

minetest.register_craftitem("animalmaterials:feather", {
	description = S("Feather"),
	image = "animalmaterials_feather.png",
})

minetest.register_craftitem("animalmaterials:milk", {
	description = S("Milk"),
	image = "animalmaterials_milk.png",
	on_use = minetest.item_eat(1),
	groups = { eatable=1 },
})

minetest.register_craftitem("animalmaterials:egg", {
	description = S("Egg"),
	image = "animalmaterials_egg.png",
})

minetest.register_craftitem("animalmaterials:egg_big", {
	description = S("Egg (big)"),
	image = "animalmaterials_egg_big.png",
})

animalmaterialsdata["animalmaterials_egg"] = {
			graphics_3d = {
				visual = "mesh",
				mesh   = "animalmaterials_egg_ent.b3d",
				textures = { "animalmaterials_egg_ent_mesh.png" },
				collisionbox = { -0.12,-0.125,-0.12,0.12,0.125,0.12 },
				visual_size = {x=1,y=1,z=1},
				}
	}

animalmaterialsdata["animalmaterials_egg_big"] = {
	graphics_3d = {
		visual = "mesh",
		mesh   = "animalmaterials_egg_ent.b3d",
		textures = { "animalmaterials_egg_ent_mesh.png" },
		collisionbox = { -0.24,-0.25,-0.24,0.24,0.25,0.24 },
		visual_size = {x=2,y=2,z=2},
		}
	}

minetest.register_craftitem("animalmaterials:bone", {
	description = S("Bone"),
	image = "animalmaterials_bone.png",
})

minetest.register_craftitem("animalmaterials:fur", {
	description = S("Fur"),
	image = "animalmaterials_fur.png",
})

minetest.register_craftitem("animalmaterials:fur_deer", {
	description = S("Deer fur"),
	image = "animalmaterials_deer_fur.png",
})

minetest.register_craftitem("animalmaterials:coat_cattle", {
	description = S("Cattle coat"),
	image = "animalmaterials_cattle_coat.png",
})

minetest.register_craftitem("animalmaterials:deer_horns", {
	description = S("Deer horns"),
	image = "animalmaterials_deer_horns.png",
})

minetest.register_craftitem("animalmaterials:ivory", {
	description = S("Ivory"),
	image = "animalmaterials_ivory.png",
})

minetest.register_craftitem("animalmaterials:scale_golden", {
	description = S("Scale (golden)"),
	image = "animalmaterials_scale_golden.png",
})
minetest.register_craftitem("animalmaterials:scale_white", {
	description = S("Scale (white)"),
	image = "animalmaterials_scale_white.png",
})
minetest.register_craftitem("animalmaterials:scale_grey", {
	description = S("Scale (grey)"),
	image = "animalmaterials_scale_grey.png",
})
minetest.register_craftitem("animalmaterials:scale_blue", {
	description = S("Scale (blue)"),
	image = "animalmaterials_scale_blue.png",
})

minetest.register_craft({
	output = "wool:white",
	recipe = {
		{"animalmaterials:feather","animalmaterials:feather","animalmaterials:feather"},
		{"animalmaterials:feather", "animalmaterials:feather","animalmaterials:feather"},
		{"animalmaterials:feather","animalmaterials:feather","animalmaterials:feather"},
	}
})

minetest.register_craft({
	output = "animalmaterials:contract",
	recipe = {
		{"default:paper"},
		{"default:paper"},
	}
})
