MANTICORE_SPINE_ENTITY = {
	physical = false,
	textures = {"manticore_spine_front.png"},
	collisionbox = {0,0,0,0,0,0},

	damage_range = 4,
	velocity = 15,
	gravity = 0.5,

	damage_outer = {
					fleshy=1,
					},
	damage_inner = {
					fleshy=2,
					},

	owner = 0,
	lifetime = 30,
	created = -1,
}


function MANTICORE_SPINE_ENTITY.on_activate(self,staticdata)
	self.created = mobf_get_current_time()
end


function MANTICORE_SPINE_ENTITY.on_step(self, dtime)
	local pos = self.object:getpos()
	local node = minetest.get_node(pos)


	--detect hit
	local objs=minetest.get_objects_inside_radius({x=pos.x,y=pos.y,z=pos.z}, 1)

	local hit = false

	for k, obj in pairs(objs) do
		if obj:get_entity_name() ~= "darts:MANTICORE_SPINE_ENTITY" and
			obj ~= self.owner then
			hit=true
		end
	end


	if hit then
        mobf_do_area_damage(pos,self.owner,self.damage_outer,self.damage_range/4)
        mobf_do_area_damage(pos,self.owner,self.damage_inner,self.damage_range/2)
		self.object:remove()
	end

	-- vanish when hitting a node
	if node.name ~= "air" then
        
		self.object:remove()
	end

	--remove after lifetime has passed
	if self.created > 0 and
		self.created + self.lifetime < mobf_get_current_time() then
		self.object:remove()
	end
end

minetest.register_entity("darts:MANTICORE_SPINE_ENTITY", MANTICORE_SPINE_ENTITY)