local S
if (minetest.get_modpath("intllib")) then
  dofile(minetest.get_modpath("intllib").."/intllib.lua")
  S = intllib.Getter(minetest.get_current_modname())
else
  S = function ( s ) return s end
end

env_flight_2 = {
			media = {
						"air"
					},
			surfaces = nil,
			max_height_above_ground = 35,
			min_height_above_ground = 15
		}

environment.register("flight_2", env_flight_2)

local dragon_groups = {
						not_in_creative_inventory=1
					}

local selectionbox_dragon = {-1, -0.3, -1, 1, 1.3, 1}

dragon_prototype = {
		name="dragon",
		modname="dragon",
		factions = {
			member = {
				"animals",
				"birds"
				}
			},
		generic = {
					description= S("dragon"),
					base_health=50,
					kill_result="default:mese 10",
					armor_groups= {
						fleshy=85,
					},
					groups = dragon_groups,
					envid="flight_2",
					population_density = 10,
				},
	sound = {
			random = {
				name="drag",
				min_delta = 10,
				chance = 0.5,
				gain = 1,
				max_hear_distance = 10,
				},
	},
		movement =  {
					min_accel=0.5,
					max_accel=1,
					max_speed=2,
					pattern="flight_pattern1",
					canfly=true,
					},
		animation = {
				fly = {
					start_frame = 120,
					end_frame   = 210,
					},
				attack = {
					start_frame = 110,
					end_frame   = 140,
					},
				},
		combat = {
			starts_attack=true,
			angryness=1,
			sun_sensitive=false,
			attack_hostile_mobs=true,
			attack_friendly_mobs=true,

			melee = {
				maxdamage=5,
				range=4,
				speed=1,
				weapon_damage_groups= { "fleshy" },
			},
		},
		states = {
				{
					name = "default",
					movgen = "probab_mov_gen",
					typical_state_time = 100,
					chance = 0,
					animation = "fly",
					graphics = {
						sprite_scale={x=2,y=2},
						sprite_div = {x=6,y=1},
						visible_height = 1,
						visible_width = 1,
					},
					graphics_3d = {
						visual = "mesh",
						mesh = "dragon.x",
						textures = {"dragon.png"},
						collisionbox = selectionbox_dragon,
						visual_size= {x=10,y=10,z=10},
						},
				},
				{
					name = "combat",
					custom_preconhandler = nil,
					movgen = "mgen_path",
					typical_state_time = 2,
					chance = 0.5,
					animation = "attack",
				},
			}
		}

--compatibility code
minetest.register_entity("dragon:dragon_spawner",
 {
	physical        = false,
	collisionbox    = { 0.0,0.0,0.0,0.0,0.0,0.0},
	visual          = "sprite",
	textures        = { "invisible.png^[makealpha:128,0,0^[makealpha:128,128,0" },
	on_activate = function(self,staticdata)
		local pos = self.object:getpos();
		minetest.add_entity(pos,"mobf:compat_spawner")
		self.object:remove()
	end,
})

--spawning code
local dragonname = dragon_prototype.modname .. ":"  .. dragon_prototype.name
local dragon_env = mobf_environment_by_name(dragon_prototype.generic.envid)

mobf_spawner_register("dragon_spawner_1",dragonname,
	{
	spawnee = dragonname,
	spawn_interval = 3000,
	spawns_per_interval = 1,
	spawn_inside = dragon_env.media,
	entities_around =
		{
			{ type="MAX",distance=1,threshold=0 },
			{ type="MAX",entityname=dragonname,
				distance=dragon_prototype.generic.population_density,threshold=2 },
		},
	relative_height =
	{
		min = dragon_env.min_height_above_ground,
		max = dragon_env.min_height_above_ground
	},
	absolute_height =
	{
		min = 10,
	},
	surfaces = {"nether:rack", "default:lava_flowing", "default:lava_source"},
	collisionbox = selectionbox_dragon
	})
mobf_add_mob(dragon_prototype)
mobs:register_egg("dragon:dragon", "Dragon", "nether_rack.png", 1)
