local max_mobs_sum = creatures.zombie_max + creatures.ghost_max - 1
if not minetest.setting_getbool("only_peaceful_mobs") then
	-- zombie
	minetest.register_abm({
		nodenames = creatures.z_spawn_nodes,
  		neighbors = {"air"},
		interval = 60,
		chance = 9000,
		action = function(pos, node, active_object_count, active_object_count_wider)
			if active_object_count_wider > max_mobs_sum then
				return
			end
			local n = minetest.get_node_or_nil(pos)
			pos.y = pos.y+1
			local ll = minetest.env:get_node_light(pos)
			local wtime = minetest.env:get_timeofday()
			if not ll then
				return
			end
			if ll >= creatures.z_ll then
				return
			end
			if ll < -1 then
				return
			end
			if minetest.env:get_node(pos).name ~= "air" then
				return
			end
			pos.y = pos.y+1
			if minetest.env:get_node(pos).name ~= "air" then
				return
			end
			creatures.spawn(pos, 1, "ghosts:zombie", 1, 15)
		end})
	-- ghost
	minetest.register_abm({
		nodenames = creatures.g_spawn_nodes,
  		neighbors = {"air"},
		interval = 60,
		chance = 9000,
		action = function(pos, node, active_object_count, active_object_count_wider)
			if active_object_count_wider > max_mobs_sum then
				return
			end
			if pos.y < 0 then return end
			pos.y = pos.y+1
			local ll = minetest.env:get_node_light(pos)
			local wtime = minetest.env:get_timeofday()
			if not ll then
				return
			end
			if ll >= creatures.g_ll then
				return
			end
			if ll < -1 then
				return
			end
			if minetest.env:get_node(pos).name ~= "air" then
				return
			end
			pos.y = pos.y+1
			if minetest.env:get_node(pos).name ~= "air" then
				return
			end
			if (wtime > 0.2 and wtime < 0.805) then
				return
			end
			creatures.spawn(pos, 1, "ghosts:ghost", 1, 15)
	end})

end
