local S
if (minetest.get_modpath("intllib")) then
	dofile(minetest.get_modpath("intllib").."/intllib.lua")
	S = intllib.Getter(minetest.get_current_modname())
else
	S = function ( s ) return s end
end

local manticore_groups = {
	not_in_creative_inventory=1
}

local selectionbox_manticore = {-1, -0.90, -1, 1, 2.0, 1}

local manticore_prototype = {
		name="manticore",
		modname="manticore",
		generic = {
			description= S("manticore"),
			base_health=40,
			kill_result="mobs:meat_raw 10",
			armor_groups= {fleshy=60},
			groups = manticore_groups,
			envid="meadow",
			population_density = 20
		},
		movement =  {
					min_accel=0.1,
					max_accel=2,
					max_speed=6,
					min_speed=3,
					pattern="stop_and_go",
					canfly=false,
					follow_speedup=5,
				},
	sound = {
			random = {
				name="mant",
				min_delta = 10,
				chance = 0.5,
				gain = 1,
				max_hear_distance = 10,
				},
	},
		combat = {
			starts_attack=true,
			angryness=1,
			sun_sensitive=true,
			attack_hostile_mobs=true,
			attack_friendly_mobs=true,

			melee = {
				maxdamage=3,
				range=4,
				speed=1,
				weapon_damage_groups= { "fleshy" },
			},
			distance = {
				attack="darts:MANTICORE_SPINE_ENTITY",
				range=15,
				min_range = 5,
				speed=1,
			},
		},
		animation = {
				walk = {
					start_frame = 40,
					end_frame   = 90,
					basevelocity = 3,
					},
				run = {
					start_frame = 91,
					end_frame   = 108,
					basevelocity = 3,
					},
				stand = {
					start_frame = 0,
					end_frame   = 40,
					},

				attack = {
					start_frame = 110,
					end_frame   = 143,
					},
			},
		states = {
				{
					name = "default",
					movgen = "none",
					typical_state_time = 30,
					chance = 0,
					animation = "stand",
					graphics = {
						sprite_scale={x=4,y=4},
						sprite_div = {x=6,y=1},
						visible_height = 1.5,
						},
					graphics_3d = {
						visual = "mesh",
						mesh = "manticore.x",
						textures = {"manticore.png"},
						collisionbox = selectionbox_manticore,
						visual_size= {x=4,y=4,z=4},
						},
				},
				{
					name = "combat",
					custom_preconhandler = nil,
					movgen = "mgen_path",
					typical_state_time = 2,
					chance = 0.05,
					animation = "attack",
				},
				{
					name = "walking",
					custom_preconhandler = nil,
					movgen = "probab_mov_gen",
					typical_state_time = 180,
					chance = 0.50,
					animation = "walk"
				},
				{
					name = "running",
					custom_preconhandler = nil,
					movgen = "probab_mov_gen",
					typical_state_time = 180,
					chance = 0.20,
					animation = "run"
				},
			},
		}

local spawneename   = manticore_prototype.modname .. ":"  .. manticore_prototype.name
local manticore_env = mobf_environment_by_name(manticore_prototype.generic.envid)

mobf_spawner_register("manticore_spawner_1",spawneename,
	{
	spawnee = spawneename,
	spawn_interval = 6000,
	spawn_inside = manticore_env.media,
	entities_around =
		{
			{ type="MAX",distance=1,threshold=0 },
			{ type="MAX",entityname=spawneename,
				distance=manticore_prototype.generic.population_density,threshold=2 }
		},

	nodes_around =
		{
			{ type="MAX", name = {"nether:rack"},distance=5,threshold=0}
		},

	absolute_height =
	{
		min = -10,
	},

	mapgen =
	{
		enabled = true,
		retries = 10,
		spawntotal = 2,
	},

	flat_area =
	{
		range = 1,
	},

	surfaces = manticore_env.surfaces.good,
	collisionbox = selectionbox_manticore
	})

mobf_add_mob(manticore_prototype)
