mobs.npc_nether_drops = {"mobs:meat"}
mobs:register_mob("mobs:npc_nether", {
	type = "npc",
	passive = false,
	damage = 4,
	attack_type = "dogfight",
	attacks_monsters = true,
	hp_min = 15,
	hp_max = 20,
	armor = 100,
	collisionbox = {-0.35,-1.0,-0.35, 0.35,0.8,0.35},
	visual = "mesh",
	mesh = "character.b3d",
	drawtype = "front",
	textures = {
		{"npc_nether.png"},
	},
	visual_size = {x=1, y=1},
	makes_footstep_sound = true,
	sounds = {},
	walk_velocity = 3,
	run_velocity = 5,
	jump = true,
	drops = {
		{name = "nether:glowstone",
		chance = 1, min = 1, max = 3},
		{name = "nether:rack",
		chance = 2, min = 1, max = 2},
		{name = "default:sword_stone",
		chance = 3, min = 1, max = 1},
	},
	water_damage = 2,
	lava_damage = 0,
	light_damage = 0,
	follow = "nether:glowstone",
	view_range = 15,
	owner = "",
	order = "follow",
	animation = {
		speed_normal = 30,		speed_run = 30,
		stand_start = 0,		stand_end = 79,
		walk_start = 168,		walk_end = 187,
		run_start = 168,		run_end = 187,
		punch_start = 200,		punch_end = 219,
	},
	on_rightclick = function(self, clicker)
		local item = clicker:get_wielded_item()
		if item:get_name() == "mobs:meat"
		or item:get_name() == "farming:bread" then
			local hp = self.object:get_hp()
			if hp + 4 > self.hp_max then
				return
			end
			if not minetest.setting_getbool("creative_mode") then
				item:take_item()
				clicker:set_wielded_item(item)
			end
			self.object:set_hp(hp + 4)
		elseif item:get_name() == "nether:glowstone" then
			if not minetest.setting_getbool("creative_mode") then
				item:take_item()
				clicker:set_wielded_item(item)
			end
			local pos = self.object:getpos()
			pos.y = pos.y + 0.5
			minetest.add_item(pos, {name = mobs.npc_nether_drops[math.random(1,#mobs.npc_nether_drops)]})
		else
			if self.owner == "" then
				self.owner = clicker:get_player_name()
			else
				if self.order == "follow" then
					self.order = "stand"
				else
					self.order = "follow"
				end
			end
		end
	end,
})

mobs:register_spawn("mobs:npc_nether", {"nether:rack"}, 20, 0, 20000, 1, -15000)
mobs:register_egg("mobs:npc_nether", "NPC Nether", "nether_brick.png", 1)
