local S
if (minetest.get_modpath("intllib")) then
  dofile(minetest.get_modpath("intllib").."/intllib.lua")
  S = intllib.Getter(minetest.get_current_modname())
else
  S = function ( s ) return s end
end

local pumpboom_groups = {
	not_in_creative_inventory=1
}

local selectionbox_pumpboom = {-0.80, -0.3, -0.80, 0.80, 0.80, 0.80}

local pumpboom_prototype = {
	name="pumpboom",
	modname="pumpboom",
	generic = {
				description= S("pumpboom"),
				base_health=15,
				kill_result="tnt:gunpowder 2",
				armor_groups= {
					fleshy=100,
				},
				groups = pumpboom_groups,
				envid="on_ground_1",
				population_density = 20
			},
	movement =  {
				min_accel=0.1,
				max_accel=1,
				max_speed=3,
				min_speed=1.0,
				pattern="run_and_jump_low",
				canfly=false,
			},
	sound = {
		random = {
			name="pump",
			min_delta = 10,
			chance = 0.5,
			gain = 1,
			max_hear_distance = 10,
			},
	},
	combat = {
		starts_attack=true,
		angryness=1,
		sun_sensitive=false,
		attack_hostile_mobs=true,
		melee = {
			maxdamage=2,
			range=1,
			speed=1,
		},
	self_destruct = {
		damage=15,
		range=5,
		node_damage_range = 1.5,
		delay=3,
		},
	},
	animation = {
			walk = {
				start_frame = 81,
				end_frame   = 97,
				basevelocity = 3,
				},
			run = {
				start_frame = 81,
				end_frame   = 97,
				basevelocity = 3,
				},
			stand = {
				start_frame = 0,
				end_frame   = 30,
				},

			attack = {
				start_frame = 100,
				end_frame   = 120,
				},
		},
	states = {
			{
				name = "default",
				movgen = "none",
				typical_state_time = 30,
				chance = 0,
				animation = "stand",
				graphics = {
					sprite_scale={x=4,y=4},
					sprite_div = {x=6,y=1},
					visible_height = 1.5,
					},
				graphics_3d = {
					visual = "mesh",
					mesh = "pumpboom.x",
					textures = {"pumpboom.png"},
					collisionbox = selectionbox_pumpboom,
					visual_size= {x=4,y=4,z=4},
					},
			},
			{
				name = "combat",
				custom_preconhandler = nil,
				movgen = "mgen_path",
				typical_state_time = 2,
				chance = 0.05,
				animation = "attack",
			},
			{
				name = "walking",
				custom_preconhandler = nil,
				movgen = "probab_mov_gen",
				typical_state_time = 180,
				chance = 0.50,
				animation = "walk"
			},
			{
				name = "running",
				custom_preconhandler = nil,
				movgen = "probab_mov_gen",
				typical_state_time = 180,
				chance = 0.20,
				animation = "run"
			},
		},
	}

local spawneename   = pumpboom_prototype.modname .. ":"  .. pumpboom_prototype.name
local pumpboom_env = mobf_environment_by_name(pumpboom_prototype.generic.envid)

mobf_spawner_register("pumpboom_spawner_1",spawneename,
	{
	spawnee = spawneename,
	spawn_interval = 4000,
	spawns_per_interval = 1,
	spawn_inside = pumpboom_env.media,
	entities_around =
		{
			type="MIN", name="pumpking:pumpking", distance=5,threshold=1
		},
	light_around =
	{
		{ type="CURRENT_MAX", distance = 2, threshold=6 }
	},
	absolute_height =
	{
		min = -10000,
		max = 10000
	},
	mapgen =
	{
		enabled = true,
		retries = 5,
		spawntotal = 100,
	},
	flat_area =
	{
		range = 1,
	},
	collisionbox = selectionbox_pumpboom
	})

mobf_add_mob(pumpboom_prototype)
mobs:register_egg("pumpboom:pumpboom", "Pumpboom", "farming_pumpkin_face.png", 1)
