local S
if (minetest.get_modpath("intllib")) then
  dofile(minetest.get_modpath("intllib").."/intllib.lua")
  S = intllib.Getter(minetest.get_current_modname())
else
  S = function ( s ) return s end
end

local spiderduck_groups = {
	not_in_creative_inventory=1
}

local selectionbox_spiderduck = {-1.85, -1.20, -1.35, 1.85, 1.20, 1.35}

local spiderduck_prototype = {
		name="spiderduck",
		modname="spiderduck",
		generic = {
			description= S("spiderduck"),
			base_health=30,
			kill_result={"farming:string 5", "not_so_simple_mobs_materials:duck_legs 8"},
			armor_groups= {
				fleshy=85,
			},
			groups = spiderduck_groups,
			envid="on_ground_1",
			population_density = 50
		},
		movement =  {
					min_accel=0.1,
					max_accel=2,
					max_speed=4,
					min_speed=2,
					pattern="stop_and_go",
					canfly=false,
					follow_speedup=5,
				},

		combat = {
			starts_attack=true,
			angryness=1,
			sun_sensitive=true,
			attack_hostile_mobs=true,

			melee = {
				maxdamage=3,
				range=4,
				speed=1,
				weapon_damage_groups= { "fleshy" },
			},
			distance = {
				attack="darts:WEBBALL_ENTITY",
				range=20,
				min_range = 5,
				speed=2,
			},
		},
		sound = {
			random = {
				name="quo",
				min_delta = 10,
				chance = 0.5,
				gain = 1,
				max_hear_distance = 10,
				},
	},
		animation = {
				walk = {
					start_frame = 70,
					end_frame   = 110,
					basevelocity = 3,
					},
				run = {
					start_frame = 70,
					end_frame   = 110,
					basevelocity = 6,
					},
				stand = {
					start_frame = 0,
					end_frame   = 20,
					},
				attack = {
					start_frame = 20,
					end_frame   = 46,
					},
				d_attack = {
					start_frame = 46,
					end_frame = 70,
					},
			},
		states = {
				{
					name = "default",
					movgen = "none",
					typical_state_time = 30,
					chance = 0,
					animation = "stand",
					graphics = {
						sprite_scale={x=4,y=4},
						sprite_div = {x=6,y=1},
						visible_height = 1.5,
						},
					graphics_3d = {
						visual = "mesh",
						mesh = "spiderduck.x",
						textures = {"spiderduck.png"},
						collisionbox = selectionbox_spiderduck,
						visual_size= {x=4,y=4,z=4},
						},
				},
				{
					name = "combat",
					custom_preconhandler = nil,
					movgen = "mgen_path",
					typical_state_time = 2,
					chance = 0.05,
					animation = "attack",
				},
				{
					name = "walking",
					custom_preconhandler = nil,
					movgen = "probab_mov_gen",
					typical_state_time = 180,
					chance = 0.50,
					animation = "walk"
				},
				{
					name = "running",
					custom_preconhandler = nil,
					movgen = "probab_mov_gen",
					typical_state_time = 180,
					chance = 0.20,
					animation = "run"
				},
			},
		}

local spawneename   = spiderduck_prototype.modname .. ":"  .. spiderduck_prototype.name
local spiderduck_env = mobf_environment_by_name(spiderduck_prototype.generic.envid)

mobf_spawner_register("spiderduck_spawner_1",spawneename,
	{
	spawnee = spawneename,
	spawn_interval = 500,
	spawn_inside = spiderduck_env.media,

	light_around =
	{
		{ type="CURRENT_MAX", distance = 2, threshold=6 }
	},
	absolute_height = {
		max = -20,
	},
	mapgen =
	{
		enabled = true,
		retries = 9,
		spawntotal = 90,
	},

	surfaces = {
				"nether:rack",
				"default:cobble",
				"default:stone",
				"default:desert_stone",
				"default:gravel"},
	collisionbox = selectionbox_spiderduck
	})

mobf_add_mob(spiderduck_prototype)
