minetest.register_craftitem("default:stick", {
	description = "Stick",
	inventory_image = "default_stick.png",
	groups = {stick=1},
})

minetest.register_craftitem("default:paper", {
	description = "Paper",
	inventory_image = "default_paper.png",
})

minetest.register_craftitem("default:book", {
	description = "Book",
	inventory_image = "default_book.png",
	groups = {book=1},
})

minetest.register_craftitem("default:coal_lump", {
	description = "Coal Lump",
	inventory_image = "default_coal_lump.png",
	groups = {coal=1, mineral=1}
})

minetest.register_craftitem("default:iron_lump", {
	description = "Iron Lump",
	inventory_image = "default_iron_lump.png",
	groups = {mineral=1}
})

minetest.register_craftitem("default:copper_lump", {
	description = "Copper Lump",
	inventory_image = "default_copper_lump.png",
	groups = {mineral=1}
})

minetest.register_craftitem("default:quartz_crystal", {
	description = "Quartz Crystal",
	inventory_image = "quartz_crystal_full.png",
	groups = {mineral=1,crystal=1}
})
minetest.register_craftitem("default:quartz_crystal_piece", {
	description = "Quartz Crystal Piece",
	inventory_image = "quartz_crystal_piece.png",
	groups = {mineral=1,crystal=1}
})

minetest.register_craftitem("default:mese_crystal", {
	description = "Mese Crystal",
	inventory_image = "default_mese_crystal.png",
	groups = {mineral=1},
	on_place = function(stack,_, pt)
		if pt.under and minetest.get_node(pt.under).name == "default:obsidian" then
			local done = make_portal(pt.under)
			if done and not minetest.setting_getbool("creative_mode") then
				stack:take_item()
			end
		end
		return stack
	end,
})

minetest.register_craftitem("default:gold_lump", {
	description = "Gold Lump",
	inventory_image = "default_gold_lump.png",
	groups = {mineral=1}
})

minetest.register_craftitem("default:diamond", {
	description = "Diamond",
	inventory_image = "default_diamond.png",
	groups = {mineral=1, gem=1, birthstone=1}
})

minetest.register_craftitem("default:garnet", {
	description = "Garnet",
	inventory_image = "gems_gem_garnet.png",
	groups = {mineral=1, gem=1, birthstone=1}
})
minetest.register_craftitem("default:aquamarine", {
	description = "Aquamarine",
	inventory_image = "gems_gem_aquamarine.png",
	groups = {mineral=1, gem=1, birthstone=1}
})
minetest.register_craftitem("default:topaz", {
	description = "Topaz",
	inventory_image = "gems_gem_topaz.png",
	groups = {mineral=1, gem=1, birthstone=1}
})
minetest.register_craftitem("default:opal", {
	description = "Opal",
	inventory_image = "gems_gem_opal.png",
	groups = {mineral=1, gem=1, birthstone=1}
})

minetest.register_craftitem("default:ruby", {
	description = "Ruby",
	inventory_image = "default_ruby.png",
	groups = {mineral=1, gem=1, birthstone=1}
})

minetest.register_craftitem("default:sapphire", {
	description = "Sapphire",
	inventory_image = "default_sapphire.png",
	groups = {mineral=1, gem=1, birthstone=1}
})

minetest.register_craftitem("default:emerald", {
	description = "Emerald",
	inventory_image = "default_emerald.png",
	groups = {mineral=1, gem=1, birthstone=1}
})

minetest.register_craftitem("default:clay_lump", {
	description = "Clay Lump",
	inventory_image = "default_clay_lump.png",
	groups = {mineral=1}
})

minetest.register_craftitem("default:steel_ingot", {
	description = "Steel Ingot",
	inventory_image = "default_steel_ingot.png",
	groups = {mineral=1, ingot=1, metal=1}
})

minetest.register_craftitem("default:iron_ingot", {
	description = "Iron Ingot",
	inventory_image = "smelter_iron_ingot.png",
	groups = {mineral=1, ingot=1, metal=1}
})

minetest.register_craftitem("default:copper_ingot", {
	description = "Copper Ingot",
	inventory_image = "default_copper_ingot.png",
	groups = {mineral=1, ingot=1, metal=1}
})

minetest.register_craftitem("default:bronze_ingot", {
	description = "Bronze Ingot",
	inventory_image = "default_bronze_ingot.png",
	groups = {mineral=1, ingot=1, metal=1}
})

minetest.register_craftitem("default:gold_ingot", {
	description = "Gold Ingot",
	inventory_image = "default_gold_ingot.png",
	groups = {mineral=1, ingot=1, metal=1}
})

minetest.register_craftitem("default:mese_crystal_fragment", {
	description = "Mese Crystal Fragment",
	inventory_image = "default_mese_crystal_fragment.png",
	groups = {mineral=1, magic=1, crystal=1},
	on_place = function(stack,_, pt)
		if pt.under and minetest.get_node(pt.under).name == "default:obsidian" then
			local done = make_portal(pt.under)
			if done and not minetest.setting_getbool("creative_mode") then
				stack:take_item()
			end
		end
		return stack
	end,
})

minetest.register_craftitem("default:clay_brick", {
	description = "Clay Brick",
	inventory_image = "default_clay_brick.png",
	groups = {brick=1}
})

minetest.register_craftitem("default:obsidian_shard", {
	description = "Obsidian Shard",
	inventory_image = "default_obsidian_shard.png",
	groups = {mineral=1, crystal=1}
})
