dofile(minetest.get_modpath("snow").."/src/abms.lua")
dofile(minetest.get_modpath("snow").."/src/basic_stairs_slabs.lua")
dofile(minetest.get_modpath("snow").."/src/crafting.lua")
dofile(minetest.get_modpath("snow").."/src/snowball.lua")
dofile(minetest.get_modpath("snow").."/src/util.lua")
dofile(minetest.get_modpath("snow").."/src/nodes.lua")
dofile(minetest.get_modpath("snow").."/src/mapgen.lua")
dofile(minetest.get_modpath("snow").."/src/falling_snow.lua")

if (minetest.get_modpath("moreblocks")) then
	dofile(minetest.get_modpath("snow").."/src/stairsplus.lua")
else
end

function snow.place(pos)
	local node = minetest.get_node_or_nil(pos)
	local drawtype = ""
	if node and minetest.registered_nodes[node.name] then
		drawtype = minetest.registered_nodes[node.name].drawtype
	end
	if node == nil then
		return
	end
	local bnode = minetest.get_node({x=pos.x,y=pos.y-1,z=pos.z})
	if node.name == "default:snow" and minetest.get_node_level(pos) < 63 then
		if minetest.get_item_group(bnode.name, "leafdecay") == 0 and snow.is_uneven(pos) ~= true then
			minetest.add_node_level(pos, 7)
		end
	elseif node.name == "default:snow" and minetest.get_node_level(pos) == 63 then
		local p = minetest.find_node_near(pos, 10, "default:dirt_with_grass")
		if p and minetest.get_node_light(p, 0.5) == 15 then
			minetest.place_node({x=pos.x,y=pos.y+1,z=pos.z},{name="default:snow"})
		else
			minetest.add_node(pos,{name="default:snowblock"})
		end
	elseif node.name ~= "default:ice" and bnode.name ~= "air" then
		if drawtype == "normal" or drawtype == "allfaces_optional" then
			minetest.place_node({x=pos.x,y=pos.y+1,z=pos.z}, {name="default:snow"})
		elseif drawtype == "plantlike" then
			pos.y = pos.y - 1
			if minetest.get_node(pos).name == "default:dirt_with_grass" then
				minetest.add_node(pos, {name="default:dirt_with_snow"})
			end
		end
	end
end

-- Checks if the snow level is even at any given pos.
-- Smooth Snow
local smooth_snow = snow.smooth_snow
snow.is_uneven = function(pos)
	if smooth_snow then
		local num = minetest.get_node_level(pos)
		local get_node = minetest.get_node
		local add_node = minetest.add_node
		local found
		local foundx
		local foundy
		local foundz
		for x=-1,1 do
		for z=-1,1 do
			local node = get_node({x=pos.x+x,y=pos.y,z=pos.z+z})
			local bnode = get_node({x=pos.x+x,y=pos.y-1,z=pos.z+z})
			local drawtype
			if node and minetest.registered_nodes[node.name] then
				drawtype = minetest.registered_nodes[node.name].drawtype
			end
			if drawtype == "plantlike" then
				if bnode.name == "default:dirt_with_grass" then
					add_node({x=pos.x+x,y=pos.y-1,z=pos.z+z}, {name="default:dirt_with_snow"})
					return true
				end
			end
			if (not(x == 0 and y == 0)) and node.name == "default:snow" and minetest.get_node_level({x=pos.x+x,y=pos.y,z=pos.z+z}) < num then
				found = true
				foundx = x
				foundz=z
			elseif node.name == "air" and bnode.name ~= "air" then
				if not (bnode.name == "default:snow") then
					snow.place({x=pos.x+x,y=pos.y-1,z=pos.z+z})
					return true
				end
			end
		end
		end
		if found then
			local node = get_node({x=pos.x+foundx,y=pos.y,z=pos.z+foundz})
			if snow.is_uneven({x=pos.x+foundx,y=pos.y,z=pos.z+foundz}) ~= true then
				minetest.add_node_level({x=pos.x+foundx,y=pos.y,z=pos.z+foundz}, 7)
			end
			return true
		end
	end
end
